#include "main.h"
#include "Imgctl.h"
#include <vector>
#include <stdio.h>
#include <stdlib.h>
#include <shlwapi.h>

static inline DWORD req2dword(Request &req,size_t index){
	char *e;
	return  strtoul(req.argument.at(index).c_str(),&e,0);
}
static inline long req2long(Request &req,size_t index){
	char *e;
	return  strtol(req.argument.at(index).c_str(),&e,0);
}
static inline HDIB req2hdib(Request &req,size_t index = 1){
	return  (HDIB)req2dword(req,index);	
}

#define ALPHA_MAX	100
static COLORREF CALLBACK AlphaPaste(LPPASTEINFO lppi)
{
	DWORD dwCol;
	BYTE r, g, b;
#pragma warning(disable:4244)
	dwCol = (DWORD)GetRValue(lppi->colDest) * lppi->lParam;
	dwCol += (DWORD)GetRValue(lppi->colSrc) * (ALPHA_MAX - lppi->lParam);
	r = (BYTE)(dwCol / ALPHA_MAX);
	dwCol = (DWORD)GetGValue(lppi->colDest) * lppi->lParam;
	dwCol += (DWORD)GetGValue(lppi->colSrc) * (ALPHA_MAX - lppi->lParam);
	g = (BYTE)(dwCol / ALPHA_MAX);
	dwCol = (DWORD)GetBValue(lppi->colDest) * lppi->lParam;
	dwCol += (DWORD)GetBValue(lppi->colSrc) * (ALPHA_MAX - lppi->lParam);
	b = (BYTE)(dwCol / ALPHA_MAX);
#pragma warning(default:4244)
	return RGB(r, g, b);
}

/*
 *	SpritePaste
 *		XvCg(F)s܂B
 *		̐F͓\tȂ悤ɏo܂B
 *		PasteDIB̈lParamŁAFCOLORREF^Ŏw肵ĉB
 */
static COLORREF CALLBACK SpritePaste(LPPASTEINFO lppi)
{
	return ((lppi->colSrc == (COLORREF)lppi->lParam) ? lppi->colDest : lppi->colSrc);
}

/*
 *	FramePaste (for v1.10B or later)
 *		zɃAt@ufBOs܂B
 *		摜̊OقǓx̍\tɂȂ܂B
 *		PasteDIB̈lParamŁAz̕sNZPʂŎw肵ĉB
 *		ȂA AlphaPaste ŗp܂B
 */
static COLORREF CALLBACK FramePaste(LPPASTEINFO lppi)
{
	long n[3];

	/* [̋̍ŏl߂ */
	n[0] = labs(lppi->lXDest - lppi->rcArea.left);
	n[1] = labs(lppi->lXDest - lppi->rcArea.right);
	n[0] = min(n[0], n[1]);
	n[1] = labs(lppi->lYDest - lppi->rcArea.top);
	n[2] = labs(lppi->lYDest - lppi->rcArea.bottom);
	n[1] = min(n[1], n[2]);
	n[0] = min(n[0], n[1]);

	/* L͈͓ȂAt@ufBO */
	if (n[0] < lppi->lParam) {
		lppi->lParam = ALPHA_MAX - (ALPHA_MAX * (n[0] + 1)) / (lppi->lParam + 1);
		lppi->colSrc = AlphaPaste(lppi);
	}

	return lppi->colSrc;
}

/*
 *	PngAlphaPaste (for v1.10B or later)
 *		PNGAtoDIBŎ擾At@`lf[^p܂B
 *		PasteDIB̈lParamŁA֐̈hDIBSrc̃At@`l
 *		HDIB^Ŏw肵ĉB
 *		ÃAt@`lf[^ł\܂B
 */
static COLORREF CALLBACK PngAlphaPaste(LPPASTEINFO lppi)
{
	LPCIMGDATA pImg;
	long lLength;
	BYTE alpha;
	DWORD dwCol;
	BYTE r, g, b;

	/* At@`lf[^擾 */
	pImg = Imgctl->_DataDIB((HDIB)lppi->lParam);
	if (!pImg) { return lppi->colSrc; }
	lLength = (((pImg->pbmi->bmiHeader.biWidth << 3) + 31) >> 5) << 2;
	alpha = *(pImg->pData + lppi->lXSrc +
		(pImg->pbmi->bmiHeader.biHeight - lppi->lYSrc - 1) * lLength);

	/* At@ufBO */
	dwCol = (DWORD)GetRValue(lppi->colDest) * (255 - alpha);
	dwCol += (DWORD)GetRValue(lppi->colSrc) * alpha;
	r = (BYTE)(dwCol / 255);
	dwCol = (DWORD)GetGValue(lppi->colDest) * (255 - alpha);
	dwCol += (DWORD)GetGValue(lppi->colSrc) * alpha;
	g = (BYTE)(dwCol / 255);
	dwCol = (DWORD)GetBValue(lppi->colDest) * (255 - alpha);
	dwCol += (DWORD)GetBValue(lppi->colSrc) * alpha;
	b = (BYTE)(dwCol / 255);

	return RGB(r, g, b);
}


CImgctl::CImgctl(std::string path)
{
	basepath.assign(path);
	std::string libpath(path);
	libpath.append("imgctl.dll");
	handle = LoadLibraryA(libpath.c_str());
	if(handle == NULL)
		return;
	// [{֐]
	_ImgctlVersion = (IMGCTLVERSION)GetProcAddress(handle,TEXT("ImgctlVersion"));
	_ImgctlBeta = (IMGCTLBETA)GetProcAddress(handle,TEXT("ImgctlBeta"));
	_ImgctlError = (IMGCTLERROR)GetProcAddress(handle,TEXT("ImgctlError"));
	_ImgctlErrorClear = (IMGCTLERRORCLEAR)GetProcAddress(handle,TEXT("ImgctlErrorClear"));
	_GetImageType = (GETIMAGETYPE)GetProcAddress(handle,TEXT("GetImageType"));
	_GetImageMType = (GETIMAGEMTYPE)GetProcAddress(handle,TEXT("GetImageMType"));
	_ToDIB = (TODIB)GetProcAddress(handle,TEXT("ToDIB"));
	_MtoDIB = (MTODIB)GetProcAddress(handle,TEXT("MtoDIB"));
	
	// [DIBf[^֐]
	_DeleteDIB = (DELETEDIB)GetProcAddress(handle,TEXT("DeleteDIB"));
	_HeadDIB = (HEADDIB)GetProcAddress(handle,TEXT("HeadDIB"));
	_PaletteDIB = (PALETTEDIB)GetProcAddress(handle,TEXT("PaletteDIB"));
	_PixelDIB = (PIXELDIB)GetProcAddress(handle,TEXT("PixelDIB"));
	_ColorDIB = (COLORDIB)GetProcAddress(handle,TEXT("ColorDIB"));
	_GetDIB = (GETDIB)GetProcAddress(handle,TEXT("GetDIB"));
	_MapDIB = (MAPDIB)GetProcAddress(handle,TEXT("MapDIB"));
	_DataDIB = (DATADIB)GetProcAddress(handle,TEXT("DataDIB"));
	_CreateDIB = (CREATEDIB)GetProcAddress(handle,TEXT("CreateDIB"));
	_CopyDIB = (COPYDIB)GetProcAddress(handle,TEXT("CopyDIB"));
	_CutDIB = (CUTDIB)GetProcAddress(handle,TEXT("CutDIB"));
	_TurnDIB = (TURNDIB)GetProcAddress(handle,TEXT("TurnDIB"));
	_DIBto24Bit = (DIBTO24BIT)GetProcAddress(handle,TEXT("DIBto24Bit"));
	_DIBto16Bit = (DIBTO16BIT)GetProcAddress(handle,TEXT("DIBto16Bit"));
	_DIBto16BitEx = (DIBTO16BITEX)GetProcAddress(handle,TEXT("DIBto16BitEx"));
	_DIBto8Bit = (DIBTO8BIT)GetProcAddress(handle,TEXT("DIBto8Bit"));
	// [24rbgDIBf[^֐]
	_PasteDIB = (PASTEDIB)GetProcAddress(handle,TEXT("PasteDIB"));
	_ResizeDIB = (RESIZEDIB)GetProcAddress(handle,TEXT("ResizeDIB"));
	_TurnDIBex = (TURNDIBEX)GetProcAddress(handle,TEXT("TurnDIBex"));
	
	// [RLE-DIBf[^֐]
	_IsRLE = (ISRLE)GetProcAddress(handle,TEXT("IsRLE"));
	_DIBtoRLE = (DIBTORLE)GetProcAddress(handle,TEXT("DIBtoRLE"));
	_RLEtoDIB = (RLETODIB)GetProcAddress(handle,TEXT("RLEtoDIB"));
	
	// [Bitmap摜֐]
	_DIBtoBMP = (DIBTOBMP)GetProcAddress(handle,TEXT("DIBtoBMP"));
	_BMPtoDIB = (BMPTODIB)GetProcAddress(handle,TEXT("BMPtoDIB"));
	_BMPMtoDIB = (BMPMTODIB)GetProcAddress(handle,TEXT("BMPMtoDIB"));
	
	// [JPEG摜֐]
	_DIBtoJPG = (DIBTOJPG)GetProcAddress(handle,TEXT("DIBtoJPG"));
	_JPGtoDIB = (JPGTODIB)GetProcAddress(handle,TEXT("JPGtoDIB"));
	_JPGMtoDIB = (JPGMTODIB)GetProcAddress(handle,TEXT("JPGMtoDIB"));
	
	// [PNG摜֐]
	_DIBtoPNG = (DIBTOPNG)GetProcAddress(handle,TEXT("DIBtoPNG"));
	_DIBtoPNGex = (DIBTOPNGEX)GetProcAddress(handle,TEXT("DIBtoPNGex"));
	_PNGtoDIB = (PNGTODIB)GetProcAddress(handle,TEXT("PNGtoDIB"));
	_PNGMtoDIB = (PNGMTODIB)GetProcAddress(handle,TEXT("PNGMtoDIB"));
	_PNGAtoDIB = (PNGATODIB)GetProcAddress(handle,TEXT("PNGAtoDIB"));
	_PNGMAtoDIB = (PNGMATODIB)GetProcAddress(handle,TEXT("PNGMAtoDIB"));
	_InfoPNG = (INFOPNG)GetProcAddress(handle,TEXT("InfoPNG"));
	_InfoPNGM = (INFOPNGM)GetProcAddress(handle,TEXT("InfoPNGM"));
	
	// [GIF摜֐]
	_DIBtoGIF = (DIBTOGIF)GetProcAddress(handle,TEXT("DIBtoGIF"));
	_DIBtoGIFex = (DIBTOGIFEX)GetProcAddress(handle,TEXT("DIBtoGIFex"));
	_DIBtoGIFAni = (DIBTOGIFANI)GetProcAddress(handle,TEXT("DIBtoGIFAni"));
	_DIBtoGIFAniEx = (DIBTOGIFANIEX)GetProcAddress(handle,TEXT("DIBtoGIFAniEx"));
	_GIFtoDIB = (GIFTODIB)GetProcAddress(handle,TEXT("GIFtoDIB"));
	_GIFMtoDIB = (GIFMTODIB)GetProcAddress(handle,TEXT("GIFMtoDIB"));
	_GIFtoDIBex = (GIFTODIBEX)GetProcAddress(handle,TEXT("GIFtoDIBex"));
	_GIFMtoDIBex = (GIFMTODIBEX)GetProcAddress(handle,TEXT("GIFMtoDIBex"));
	
	// [tB^֐]
	_GrayDIB = (GRAYDIB)GetProcAddress(handle,TEXT("GrayDIB"));
	_ReplaceDIB = (REPLACEDIB)GetProcAddress(handle,TEXT("ReplaceDIB"));
	_RepaintDIB = (REPAINTDIB)GetProcAddress(handle,TEXT("RepaintDIB"));
	_TableDIB = (TABLEDIB)GetProcAddress(handle,TEXT("TableDIB"));
	// [Fϊe[u֐]
	_ToneDIB = (TONEDIB)GetProcAddress(handle,TEXT("ToneDIB"));
	_ShadeDIB = (SHADEDIB)GetProcAddress(handle,TEXT("ShadeDIB"));
	_GammaDIB = (GAMMADIB)GetProcAddress(handle,TEXT("GammaDIB"));
	_ContrastDIB = (CONTRASTDIB)GetProcAddress(handle,TEXT("ContrastDIB"));
	
	// [ʊ֘A֐]
	_DIBtoDC = (DIBTODC)GetProcAddress(handle,TEXT("DIBtoDC"));
	_DIBtoDCex = (DIBTODCEX)GetProcAddress(handle,TEXT("DIBtoDCex"));
	_DIBtoDCex2 = (DIBTODCEX2)GetProcAddress(handle,TEXT("DIBtoDCex2"));
	_DCtoDIB = (DCTODIB)GetProcAddress(handle,TEXT("DCtoDIB"));
}

#define BUF_SIZE 1024
// [{֐]
HGLOBAL CImgctl::ImgctlVersion(Request &req,long *len){
	char buf[BUF_SIZE];
	sprintf_s(buf,RES_MES_OK "Result: %u" CRLF CHARSET CRLF,_ImgctlVersion());
	return set_return(buf,len);
}
HGLOBAL CImgctl::ImgctlBeta(Request &req,long *len){
	char buf[BUF_SIZE];
	sprintf_s(buf,RES_MES_OK "Result: %u" CRLF CHARSET CRLF,_ImgctlBeta());
	return set_return(buf,len);
}
HGLOBAL CImgctl::ImgctlError(Request &req,long *len){
	DWORD ecode = _ImgctlError();
	char *message;
	
	switch(ecode){
		case ICERR_NONE:
			message = "G[B";break;
		case ICERR_FILE_OPEN:
			message = "t@CI[voȂB";break;
		case ICERR_FILE_READ:
			message = "t@C̓ǂݎ肪oȂB";break;
		case ICERR_FILE_WRITE:
			message = "t@Cւ݂̏oȂB";break;
		case ICERR_FILE_TYPE:
			message = "t@C̉摜^Cvs(Ή)łB";break;
		case ICERR_FILE_NULL:
			message = "t@CNULLݒ肳ĂB";break;
		case ICERR_FILE_SEEK:
			message = "t@C̃V[NoȂB";break;
		case ICERR_FILE_SIZE:
			message = "t@C̃TCYȂB";break;
		case ICERR_PARAM_NULL:
			message = "֐̈ɕsNULLݒ肳ĂB";break;
		case ICERR_PARAM_SIZE:
			message = "f[^擾ɕKvȃTCY𖞂ĂȂB";break;
		case ICERR_PARAM_TYPE:
			message = "^Cv̐ݒ肪słB";break;
		case ICERR_PARAM_RANGE:
			message = "̒l͈͊OłB";break;
		case ICERR_MEM_ALLOC:
			message = "̎擾oȂB";break;
		case ICERR_MEM_SIZE:
			message = "̃TCYȂB";break;
		case ICERR_IMG_COMPRESS:
			message = "摜f[^̈kw肪słB";break;
		case ICERR_IMG_RLESIZE:
			message = "摜f[^RLETCYݒ肳ĂȂB";break;
		case ICERR_IMG_BITCOUNT:
			message = "摜f[^̃rbgsłB";break;
		case ICERR_IMG_AREA:
			message = "摜f[^̕or񂪕słB";break;
		case ICERR_IMG_RLETOP:
			message = "摜f[^RLẼgbv_Eł(Ή)B";break;
		case ICERR_DIB_RLECOMP:
			message = "DIBf[^RLE-DIBɈkoȂB";break;
		case ICERR_DIB_RLEEXP:
			message = "RLE-DIBf[^DIBf[^ɐLoȂB";break;
		case ICERR_DIB_RLEBIT:
			message = "RLE-DIBf[^ŗL蓾ȂrbgłB";break;
		case ICERR_DIB_NULL:
			message = "DIBf[^nhNULLłB";break;
		case ICERR_DIB_UPPER16:
			message = "DIBf[^16rbgȏłB";break;
		case ICERR_BMP_FILEHEAD:
			message = "t@Cwb_BMP`(""BM"")łȂB";break;
		case ICERR_BMP_HEADSIZE:
			message = "wb_̃TCY񂪕słB";break;
		case ICERR_BMP_IMGSIZE:
			message = "摜̏c邢͉ݒ肳ĂȂB";break;
		case ICERR_BMP_COMPRESS:
			message = "摜̈kw肪słB";break;
		case ICERR_RLE_TOPDOWN:
			message = "RLE-DIB̃gbv_EBMPł(Ή)B";break;
		case ICERR_RLE_DATASIZE:
			message = "RLE-DIB̃f[^TCYsłB";break;
		case ICERR_JPEG_LIBERR:
			message = "JPEGCũG[B";break;
		case ICERR_PNG_LIBERR:
			message = "PNGCũG[B";break;
		case ICERR_PNG_NOALPHA:
			message = "PNGɃAt@`l݂ȂB";break;
		case ICERR_GIF_FILEHEAD:
			message = "GIFwb_ȂB";break;
		case ICERR_GIF_BLOCK:
			message = "GIFubNȂB";break;
		case ICERR_API_STRETCH:
			message = "API֐StratchBltG[B";break;
		case ICERR_API_SETMODE:
			message = "API֐SetStretchBltModeG[B";break;
		case ICERR_API_SECTION:
			message = "API֐CreateDIBSectionG[B";break;
		case ICERR_API_COMDC:
			message = "API֐CreateCompatibleDCG[B";break;
		case ICERR_API_SELOBJ:
			message = "API֐SelectObjectG[B";break;
		case ICERR_API_BITBLT:
			message = "API֐BitBltG[B";break;
		default:
			message = "";break;
	}
	char buf[BUF_SIZE];
	sprintf_s(buf,RES_MES_OK "Result: %s" CRLF 
		"Value0: %d" CRLF "Value1: %s" CRLF CHARSET CRLF,
		message,ecode,message);

	return set_return(buf,len);
}
HGLOBAL CImgctl::ImgctlErrorClear(Request &req,long *len){
	_ImgctlErrorClear();
	return set_return(RES_MES_NO CHARSET CRLF,len);
}
HGLOBAL CImgctl::GetImageType(Request &req,long *len){
	DWORD flag;
	std::string filename;
	char *mes1=NULL,*mes2=NULL;
	conv_multi(req.argument.at(1),filename,req.charset,SJIS);
	char path[MAX_PATH];
	PathCombine(path,basepath.c_str(),filename.c_str());
	switch(_GetImageType(path,&flag)){
		case IMG_BMP:
			mes1 = "BITMAP";
			break;
		case IMG_JPEG:
			mes1 = "JPEG";
			mes2 = flag ? "Exif" : "JFIF";
			break;
		case IMG_PNG:
			mes1 = "PNG";
			break;
		case IMG_GIF:
			mes1 = "GIF";
			if(flag == 87)
				mes2 = "GIF87a";
			else if(flag == 89)
				mes2 = "GIF89";
			break;
		case IMG_TIFF:
			mes1 = "TIFF";
			break;
		case IMG_PIC:
			mes1 = "PIC";
			break;
		case IMG_MAG:
			mes1 = "MAG";
			if(flag == 1)
				mes2 = "01A";
			else if(flag == 2)
				mes2 = "01B";
			break;
		case IMG_PCX:
			mes1 = "PCX";
			break;
		case IMG_UNKNOWN:
			mes1 = "UNKNOWN";
			break;
		case IMG_ERROR:
			return set_return(ERR_MES,len);
	}
	char buf[BUF_SIZE];
	sprintf_s(buf,RES_MES_OK "Result: %s" CRLF,mes1);
	std::string buffer(buf);
	if(mes2 != NULL){
		sprintf_s(buf,"Value0: %s" CRLF "Value1: %s" CRLF,mes1,mes2);
		buffer.append(buf);
	}
	sprintf_s(buf,CHARSET CRLF);
	buffer.append(buf);
	return set_return(buffer,len);
}
HGLOBAL CImgctl::GetImageMType(Request &req,long *len){
	return 0;
}
HGLOBAL CImgctl::ToDIB(Request &req,long *len){
	char buf[BUF_SIZE];
	char path[MAX_PATH];
	PathCombine(path,basepath.c_str(),req.argument.at(1).c_str());
	
	HDIB h = _ToDIB(path);
	dib_list.push_back(h);
	sprintf_s(buf,RES_MES_OK "Result: %lu" CRLF CHARSET CRLF,h);
	return set_return(buf,len);
}
HGLOBAL CImgctl::MtoDIB(Request &req,long *len){
	return 0;
}

// [DIBf[^֐]
HGLOBAL CImgctl::DeleteDIB(Request &req,long *len){
	HDIB h = req2hdib(req);
	if(_DeleteDIB(h)){
		dib_list.remove(h);
		return set_return(RES_MES_NO CHARSET CRLF,len);
	}else
		return set_return(ERR_MES,len);
	
}
HGLOBAL CImgctl::HeadDIB(Request &req,long *len){
	BITMAPINFOHEADER bmi;
	HDIB h = req2hdib(req);
		char buf[BUF_SIZE]={0,};

	if(_HeadDIB(h,&bmi)){
		char *cmpr_name = NULL;
		switch(bmi.biCompression){
			case BI_RGB:
				cmpr_name = "RGB";break;
			case BI_RLE8:
				cmpr_name = "RLE8";break;
			case BI_RLE4:
				cmpr_name = "RLE4";break;
			case BI_BITFIELDS:
				cmpr_name = "BITFIELDS";break;
		}
		sprintf_s(buf,
		  RES_MES_OK "Result: %ld,%ld,%u,%s,%lu,%ld,%ld,%lu" CRLF
		  "Value0: %ld" CRLF
		  "Value1: %ld" CRLF
		  "Value2: %u" CRLF
		  "Value3: %s" CRLF
		  "Value4: %lu" CRLF
		  "Value5: %ld" CRLF
		  "Value6: %ld" CRLF
		  "Value7: %lu" CRLF CHARSET CRLF,
		  bmi.biWidth,bmi.biHeight,bmi.biBitCount,cmpr_name,bmi.biSizeImage,
		  bmi.biXPelsPerMeter,bmi.biYPelsPerMeter,bmi.biClrUsed,
		  bmi.biWidth,bmi.biHeight,bmi.biBitCount,cmpr_name,bmi.biSizeImage,
		  bmi.biXPelsPerMeter,bmi.biYPelsPerMeter,bmi.biClrUsed
		);
		return set_return(buf,len);
	}else{
		return set_return(ERR_MES,len);
	}	
}
HGLOBAL CImgctl::PaletteDIB(Request &req,long *len){
	HGLOBAL hGmem;
	HDIB h = req2hdib(req);
	DWORD dwClrNum = req2dword(req,2);
	RGBQUAD *rgb = new RGBQUAD[dwClrNum];
	DWORD res = _PaletteDIB(h,rgb,dwClrNum);
	
	if(res == 0){
		hGmem = set_return(ERR_MES,len);
	}else{
		char buf[BUF_SIZE];
		sprintf_s(buf,RES_MES_OK "Result: %lu" CRLF,res);
		std::string buffer(buf);
		for(DWORD i=0;i<res;i++){
			sprintf_s(buf,RES_MES_OK "Value%lu: %lu" CRLF,
			  i,rgb[i].rgbReserved<<24|rgb[i].rgbBlue<<16|rgb[i].rgbGreen<<8|rgb[i].rgbRed);
			  buffer.append(buf);
		}
		sprintf_s(buf,CHARSET CRLF);
		buffer.append(buf);
		hGmem = set_return(buffer,len);
	}
	delete [] rgb;
	return hGmem;
}
HGLOBAL CImgctl::PixelDIB(Request &req,long *len){
	HDIB h = req2hdib(req);	
	long x = req2long(req,2),y = req2long(req,3);
	COLORREF color = _PixelDIB(h,x,y);
	if(color == 0xFFFFFFFF){
		return set_return(ERR_MES,len);
	}
	char buf[BUF_SIZE];
	sprintf_s(buf,RES_MES_OK "Result: %lu" CRLF CHARSET CRLF,color);
	return set_return(buf,len);
}
HGLOBAL CImgctl::ColorDIB(Request &req,long *len){
	HDIB h = req2hdib(req);	
	DWORD cnt = _ColorDIB(h);
	if(cnt == 0){
		return set_return(ERR_MES,len);
	}
	char buf[BUF_SIZE];
	sprintf_s(buf,RES_MES_OK "Result: %lu" CRLF CHARSET CRLF,cnt);
	return set_return(buf,len);
}
HGLOBAL CImgctl::GetDIB(Request &req,long *len){
	return 0;
}
HGLOBAL CImgctl::MapDIB(Request &req,long *len){
	return 0;
}
HGLOBAL CImgctl::DataDIB(Request &req,long *len){
	return 0;
}
HGLOBAL CImgctl::CreateDIB(Request &req,long *len){
	return 0;
}
HGLOBAL CImgctl::CopyDIB(Request &req,long *len){
	HDIB h1 = req2hdib(req),	
		 h2 = _CopyDIB(h1);
	dib_list.push_back(h2);
	char buf[BUF_SIZE];
	sprintf_s(buf,RES_MES_OK "Result: %lu" CRLF CHARSET CRLF,h2);
	return set_return(buf,len);
}
HGLOBAL CImgctl::CutDIB(Request &req,long *len){
	HDIB h1 = req2hdib(req);	
	long x = req2long(req,2),y = req2long(req,3),
		 w = req2long(req,4),h = req2long(req,5);
	HDIB h2 = _CutDIB(h1,x,y,w,h);
	dib_list.push_back(h2);
	char buf[BUF_SIZE];
	sprintf_s(buf,RES_MES_OK "Result: %lu" CRLF CHARSET CRLF,h2);
	return set_return(buf,len);
}
HGLOBAL CImgctl::TurnDIB(Request &req,long *len){
	HDIB h = req2hdib(req);	
	long turn = req2long(req,2);
	if(_TurnDIB(h,turn))
		return set_return(RES_MES_NO CHARSET CRLF,len);
	else
		return set_return(ERR_MES,len);
}
HGLOBAL CImgctl::DIBto24Bit(Request &req,long *len){
	HDIB h = req2hdib(req);	
	if(_DIBto24Bit(h))
		return set_return(RES_MES_NO CHARSET CRLF,len);
	else
		return set_return(ERR_MES,len);
}
HGLOBAL CImgctl::DIBto16Bit(Request &req,long *len){
	HDIB h = req2hdib(req);	
	if(_DIBto16Bit(h,0))
		return set_return(RES_MES_NO CHARSET CRLF,len);
	else
		return set_return(ERR_MES,len);
}
HGLOBAL CImgctl::DIBto16BitEx(Request &req,long *len){
	HDIB h = req2hdib(req);	
	if(_DIBto16BitEx(h,0,TOBIT_DEFAULT))
		return set_return(RES_MES_NO CHARSET CRLF,len);
	else
		return set_return(ERR_MES,len);
}
HGLOBAL CImgctl::DIBto8Bit(Request &req,long *len){
	HDIB h = req2hdib(req);	
	if(_DIBto8Bit(h,0,TOBIT_DEFAULT))
		return set_return(RES_MES_NO CHARSET CRLF,len);
	else
		return set_return(ERR_MES,len);
}
// [24rbgDIBf[^֐]
HGLOBAL CImgctl::PasteDIB(Request &req,long *len){
	HDIB dest = req2hdib(req),
		 src  = req2hdib(req,6);
	long dest_x = req2long(req,2),dest_y = req2long(req,3),
		 w = req2long(req,4),h = req2long(req,5),
		 src_x = req2long(req,7),src_y = req2long(req,8);
	PASTEPROC proc = NULL;
	LPARAM lp = 0;
	
	std::string &method = req.argument.at(9);
	if(method.compare("alpha")==0){
		proc = AlphaPaste;
		lp = (LPARAM)req2long(req,10);
		if(lp < 0)
			lp = 0;
		else if(lp > ALPHA_MAX)
			lp = ALPHA_MAX;
	}else if(method.compare("sprite")==0){
		proc = SpritePaste;
		lp = (LPARAM)req2dword(req,10);
	}else if(method.compare("frame")==0){
		proc = FramePaste;
		lp = (LPARAM)req2long(req,10);
	}else if(method.compare("pngalpha")==0){
		proc = PngAlphaPaste;
		lp = (LPARAM)req2dword(req,10);
	}
	if(_PasteDIB(dest,dest_x,dest_y,w,h,src,src_x,src_y,proc,lp)){
		return set_return(RES_MES_NO CHARSET CRLF,len);
	}else{
		return set_return(ERR_MES,len);
	}
}
HGLOBAL CImgctl::ResizeDIB(Request &req,long *len){
	HDIB h = req2hdib(req);	
	long width = req2long(req,2),height = req2long(req,3);
	if(_ResizeDIB(h,width,height)){
		return set_return(RES_MES_NO CHARSET CRLF,len);
	}else{
		return set_return(ERR_MES,len);
	}
}
HGLOBAL CImgctl::TurnDIBex(Request &req,long *len){
	HDIB h = req2hdib(req);	
	long turn = req2long(req,2);
	COLORREF color = req2dword(req,3);
	if(_TurnDIBex(h,turn,color)){
		return set_return(RES_MES_NO CHARSET CRLF,len);
	}else{
		return set_return(ERR_MES,len);
	}
}

// [RLE-DIBf[^֐]
HGLOBAL CImgctl::IsRLE(Request &req,long *len){
	HDIB h = req2hdib(req);	
	char buf[BUF_SIZE];
	sprintf_s(buf,RES_MES_OK "Result: %ld" CRLF CHARSET CRLF,(int)_IsRLE(h));
	return set_return(buf,len);
}
HGLOBAL CImgctl::DIBtoRLE(Request &req,long *len){
	HDIB h = req2hdib(req);	
	if(_DIBtoRLE(h)){
		return set_return(RES_MES_NO CHARSET CRLF,len);
	}else{
		return set_return(ERR_MES,len);
	}
}
HGLOBAL CImgctl::RLEtoDIB(Request &req,long *len){
	HDIB h = req2hdib(req);	
	if(_RLEtoDIB(h)){
		return set_return(RES_MES_NO CHARSET CRLF,len);
	}else{
		return set_return(ERR_MES,len);
	}
}

// [Bitmap摜֐]
HGLOBAL CImgctl::DIBtoBMP(Request &req,long *len){
	HDIB h = req2hdib(req,2);
	char path[MAX_PATH];
	PathCombine(path,basepath.c_str(),req.argument.at(1).c_str());
	if(_DIBtoBMP(path,h)){
		return set_return(RES_MES_NO CHARSET CRLF,len);
	}else{
		return set_return(ERR_MES,len);
	}
}
HGLOBAL CImgctl::BMPtoDIB(Request &req,long *len){
	char buf[BUF_SIZE];
	char path[MAX_PATH];
	PathCombine(path,basepath.c_str(),req.argument.at(1).c_str());

	HDIB h = _BMPtoDIB(path);
	dib_list.push_back(h);
	sprintf_s(buf,RES_MES_OK "Result: %lu" CRLF CHARSET CRLF,h);
	return set_return(buf,len);
}
HGLOBAL CImgctl::BMPMtoDIB(Request &req,long *len){
	return 0;
}

// [JPEG摜֐]
HGLOBAL CImgctl::DIBtoJPG(Request &req,long *len){
	HDIB h = req2hdib(req,2);
	int quality = req2long(req,3);
	BOOL progression = req2long(req,4);
	char path[MAX_PATH];
	PathCombine(path,basepath.c_str(),req.argument.at(1).c_str());
	if(_DIBtoJPG(path,h,quality,progression)){
		return set_return(RES_MES_NO CHARSET CRLF,len);
	}else{
		return set_return(ERR_MES,len);
	}
}
HGLOBAL CImgctl::JPGtoDIB(Request &req,long *len){
	char buf[BUF_SIZE];
	char path[MAX_PATH];
	PathCombine(path,basepath.c_str(),req.argument.at(1).c_str());

	HDIB h = _JPGtoDIB(path);
	dib_list.push_back(h);
	sprintf_s(buf,RES_MES_OK "Result: %lu" CRLF CHARSET CRLF,h);
	return set_return(buf,len);
}
HGLOBAL CImgctl::JPGMtoDIB(Request &req,long *len){
	return 0;
}

// [PNG摜֐]
HGLOBAL CImgctl::DIBtoPNG(Request &req,long *len){
	HDIB h = req2hdib(req,2);
	BOOL interlacing = req2long(req,3);
	char path[MAX_PATH];
	PathCombine(path,basepath.c_str(),req.argument.at(1).c_str());
	if(_DIBtoPNG(path,h,interlacing)){
		return set_return(RES_MES_NO CHARSET CRLF,len);
	}else{
		return set_return(ERR_MES,len);
	}
}
HGLOBAL CImgctl::DIBtoPNGex(Request &req,long *len){
	return 0;
}
HGLOBAL CImgctl::PNGtoDIB(Request &req,long *len){
	char buf[BUF_SIZE];
	char path[MAX_PATH];
	PathCombine(path,basepath.c_str(),req.argument.at(1).c_str());

	HDIB h = _PNGtoDIB(path);
	dib_list.push_back(h);
	sprintf_s(buf,RES_MES_OK "Result: %lu" CRLF CHARSET CRLF,h);
	return set_return(buf,len);
}
HGLOBAL CImgctl::PNGMtoDIB(Request &req,long *len){
	return 0;
}
HGLOBAL CImgctl::PNGAtoDIB(Request &req,long *len){
	char buf[BUF_SIZE];
	char path[MAX_PATH];
	PathCombine(path,basepath.c_str(),req.argument.at(1).c_str());

	HDIB h = _PNGAtoDIB(path);
	dib_list.push_back(h);
	sprintf_s(buf,RES_MES_OK "Result: %lu" CRLF CHARSET CRLF,h);
	return set_return(buf,len);
}
HGLOBAL CImgctl::PNGMAtoDIB(Request &req,long *len){
	return 0;
}
HGLOBAL CImgctl::InfoPNG(Request &req,long *len){
	return 0;
}
HGLOBAL CImgctl::InfoPNGM(Request &req,long *len){
	return 0;
}

// [GIF摜֐]
HGLOBAL CImgctl::DIBtoGIF(Request &req,long *len){
	HDIB h = req2hdib(req,2);
	BOOL interlacing = req2long(req,3);
	char path[MAX_PATH];
	PathCombine(path,basepath.c_str(),req.argument.at(1).c_str());
	if(_DIBtoGIF(path,h,interlacing)){
		return set_return(RES_MES_NO CHARSET CRLF,len);
	}else{
		return set_return(ERR_MES,len);
	}
}
HGLOBAL CImgctl::DIBtoGIFex(Request &req,long *len){
	return 0;
}
HGLOBAL CImgctl::DIBtoGIFAni(Request &req,long *len){
	char path[MAX_PATH];
	PathCombine(path,basepath.c_str(),req.argument.at(1).c_str());
	
	std::vector<HDIB> h;
	h.resize(req.argument.size()-4);
	size_t i;
	for(i=2;i<req.argument.size()-1;i++)
		h[i] = req2hdib(req,i);
	
	WORD wTime = (WORD)req2dword(req,i);
	
	if(_DIBtoGIFAni(path,&h[0],(DWORD)i-2,wTime)){
		return set_return(RES_MES_NO CHARSET CRLF,len);
	}else{
		return set_return(ERR_MES,len);
	}
}
HGLOBAL CImgctl::DIBtoGIFAniEx(Request &req,long *len){
	return 0;
}
HGLOBAL CImgctl::GIFtoDIB(Request &req,long *len){
	char buf[BUF_SIZE];
	char path[MAX_PATH];
	PathCombine(path,basepath.c_str(),req.argument.at(1).c_str());

	HDIB h = _GIFtoDIB(path);
	dib_list.push_back(h);
	sprintf_s(buf,RES_MES_OK "Result: %lu" CRLF CHARSET CRLF,h);
	return set_return(buf,len);
}
HGLOBAL CImgctl::GIFMtoDIB(Request &req,long *len){
	return 0;
}
HGLOBAL CImgctl::GIFtoDIBex(Request &req,long *len){
	return 0;
}
HGLOBAL CImgctl::GIFMtoDIBex(Request &req,long *len){
	return 0;
}

// [tB^֐]
HGLOBAL CImgctl::GrayDIB(Request &req,long *len){
	HDIB h = req2hdib(req);
	WORD strength = (WORD)req2dword(req,2);
	if(strength>255)
		strength = 255;
	if(_GrayDIB(h,strength)){
		return set_return(RES_MES_NO CHARSET CRLF,len);
	}else{
		return set_return(ERR_MES,len);
	}
}
HGLOBAL CImgctl::ReplaceDIB(Request &req,long *len){
	HDIB h = req2hdib(req);
	WORD rgb[3];
	
	for(size_t i=0;i<3;i++){
		std::string &color = req.argument.at(i+2);
		if(color.compare("red")){
			rgb[i] = REP_RED;
		}else if(color.compare("green")){
			rgb[i] = REP_GREEN;
		}else if(color.compare("blue")){
			rgb[i] = REP_BLUE;
		}else{
			return set_return(BAD_MES,len);
		} 
	}
	
	if(_ReplaceDIB(h,rgb[0],rgb[1],rgb[2])){
		return set_return(RES_MES_NO CHARSET CRLF,len);
	}else{
		return set_return(ERR_MES,len);
	}
}
HGLOBAL CImgctl::RepaintDIB(Request &req,long *len){
	HDIB h = req2hdib(req);
	std::vector<REPAINTINFO> ri;
	
	size_t maxsize = (req.argument.size()-2)/2;
	ri.resize(maxsize);
	for(size_t i=0;i<maxsize;i++){
		ri[i].colBefore = req2dword(req,i*2+2);
		ri[i].colAfter  = req2dword(req,i*2+3);
	}
	
	if(_RepaintDIB(h,&ri[0],(DWORD)maxsize)){
		return set_return(RES_MES_NO CHARSET CRLF,len);
	}else{
		return set_return(ERR_MES,len);
	}
}
HGLOBAL CImgctl::TableDIB(Request &req,long *len){
	return 0;
}
// [Fϊe[u֐]
HGLOBAL CImgctl::ToneDIB(Request &req,long *len){
	HDIB h = req2hdib(req);
	short r = (short)req2long(req,2),
		  g = (short)req2long(req,3),
		  b = (short)req2long(req,4);
		  
	if(r > 255) r = 255;
	if(g > 255) g = 255;
	if(b > 255) b = 255;
	
	if(r < -255) r = -255;
	if(g < -255) g = -255;
	if(b < -255) b = -255;

	if(_ToneDIB(h,r,g,b)){
		return set_return(RES_MES_NO CHARSET CRLF,len);
	}else{
		return set_return(ERR_MES,len);
	}
}
HGLOBAL CImgctl::ShadeDIB(Request &req,long *len){
	HDIB h = req2hdib(req);
	DWORD r = req2dword(req,2),
		  g = req2dword(req,3),
		  b = req2dword(req,4);
		  
	if(r > 25500) r = 25500;
	if(g > 25500) g = 25500;
	if(b > 25500) b = 25500;
	
	if(r < 0) r = 0;
	if(g < 0) g = 0;
	if(b < 0) b = 0;

	if(_ShadeDIB(h,r,g,b)){
		return set_return(RES_MES_NO CHARSET CRLF,len);
	}else{
		return set_return(ERR_MES,len);
	}
}
HGLOBAL CImgctl::GammaDIB(Request &req,long *len){
	HDIB h = req2hdib(req);
	WORD r = (WORD)req2dword(req,2),
		 g = (WORD)req2dword(req,3),
		 b = (WORD)req2dword(req,4);
		  
	if(_GammaDIB(h,r,g,b)){
		return set_return(RES_MES_NO CHARSET CRLF,len);
	}else{
		return set_return(ERR_MES,len);
	}
}
HGLOBAL CImgctl::ContrastDIB(Request &req,long *len){
	HDIB h = req2hdib(req);
	short r = (short)req2long(req,2),
		  g = (short)req2long(req,3),
		  b = (short)req2long(req,4);
		  
	if(r > 255) r = 255;
	if(g > 255) g = 255;
	if(b > 255) b = 255;
	
	if(r < -255) r = -255;
	if(g < -255) g = -255;
	if(b < -255) b = -255;

	if(_ContrastDIB(h,r,g,b)){
		return set_return(RES_MES_NO CHARSET CRLF,len);
	}else{
		return set_return(ERR_MES,len);
	}
}

// [ʊ֘A֐]
HGLOBAL CImgctl::DIBtoDC(Request &req,long *len){
	return 0;
}
HGLOBAL CImgctl::DIBtoDCex(Request &req,long *len){
	return 0;
}
HGLOBAL CImgctl::DIBtoDCex2(Request &req,long *len){
	return 0;
}
HGLOBAL CImgctl::DCtoDIB(Request &req,long *len){
	return 0;
}

// ⏕
HGLOBAL CImgctl::DeleteAllDIB(Request &req,long *len){
	char buf[BUF_SIZE];
	sprintf_s(buf,RES_MES_OK "Result: %d" CRLF CHARSET CRLF,_DeleteAllDIB());
	return set_return(buf,len);
}

int CImgctl::_DeleteAllDIB(void){
	int cnt = 0;
	std::list<HDIB>::iterator itr = dib_list.begin(),
							  itr_end = dib_list.end(); 
	for(;itr != itr_end;itr++){
		if(!_DeleteDIB(*itr))
			cnt++;
	}
	return cnt;
}


CImgctl::~CImgctl(void)
{
	_DeleteAllDIB();
	FreeLibrary(handle);
	handle = NULL;
}
bool CImgctl::IsEnable(void)
{
	return handle!=NULL;
}
