#include <vector>
#include <string>
#include <sstream>
#include <memory.h>
#include <windows.h>
#include "main.h"

CImgctl *Imgctl = NULL;

extern "C" __declspec(dllexport) BOOL __cdecl load(HGLOBAL h, long len){
	std::string path;
	path.resize(len,'\0');
	memmove((void*)path.c_str(),(void*)h,len);
	GlobalFree(h);
	
	Imgctl = new CImgctl(path);
	if(Imgctl->IsEnable())
		return true;
	else{
		delete Imgctl;
		Imgctl = NULL;
		return false;
	}
}

extern "C" __declspec(dllexport) BOOL __cdecl unload(){
	delete Imgctl;
	Imgctl = NULL;
	return true;
}

extern "C" __declspec(dllexport) HGLOBAL __cdecl request(HGLOBAL h, long *len){
	if(Imgctl == NULL){
		GlobalFree(h);
		return set_return(ERR_MES,len);
	}
	
	std::string req;
	std::wstring wreq;
	
	req.resize(*len,'\0');
	memmove((void*)req.c_str(),(void*)h,*len);
	GlobalFree(h);

	mes(req.c_str());
	
	Request r;
	std::stringstream request(req);
	std::getline(request,r.cmd_version);
	r.cmd_version.erase(r.cmd_version.size()-1);
	while(std::getline(request,req)){
		if(req.size() <= 1) continue;
		req.erase(req.size()-1);
		size_t index = req.find(": ");
		if(index == std::string::npos) continue;
		if(req.compare(0,strlen("Argument"),"Argument",strlen("Argument"))==0){
			size_t i = req.find_first_of("0123456789"); 
			if(i > index) continue; 
			int num = atoi(req.substr(i,index-i).c_str());			
			
			//mes_i(num);
			
			if(r.argument.size() < (size_t)num+1){
				r.argument.resize(num+1);
			}
			r.argument[num] = req.substr(index+2);
		}else if(req.compare(0,index,"SecurityLevel",strlen("SecurityLevel"))==0){
			if(req.compare(index+2,std::string::npos,"Local",strlen("Local"))==0)
				r.security_level = Local;
			else
				r.security_level = External;
		}else if(req.compare(0,index,"Charset",strlen("Charset"))==0){
			// Shift_JIS|ISO-2022-JP|EUC-JP|UTF-8
			if(req.compare(index+2,std::string::npos,"Shift_JIS",strlen("Shift_JIS"))==0)
				r.charset = SJIS;
			else if(req.compare(index+2,std::string::npos,"ISO-2022-JP",strlen("ISO-2022-JP"))==0)
				r.charset = JIS;
			else if(req.compare(index+2,std::string::npos,"EUC-JP",strlen("EUC-JP"))==0)
				r.charset = EUCJP;
			else if(req.compare(index+2,std::string::npos,"UTF-8",strlen("UTF-8"))==0)
				r.charset = UTF8N;
			else
				r.charset = SJIS;
		}else if(req.compare(0,index,"Sender",strlen("Sender"))==0){
			r.sender = req.substr(index+2);
		}		
	}
	
	if(r.cmd_version.compare(EXECUTE)==0){
		std::string &cmd = r.argument.at(0);
		HGLOBAL hGmem = 0; 

		// [{֐]
		if(cmd.compare("ImgctlVersion")==0)
			hGmem = Imgctl->ImgctlVersion(r,len);
		else if(cmd.compare("ImgctlBeta")==0)
			hGmem = Imgctl->ImgctlBeta(r,len);
		else if(cmd.compare("ImgctlError")==0)
			hGmem = Imgctl->ImgctlError(r,len);
		else if(cmd.compare("ImgctlErrorClear")==0)
			hGmem = Imgctl->ImgctlErrorClear(r,len);
		else if(cmd.compare("GetImageType")==0)
			hGmem = Imgctl->GetImageType(r,len);
		else if(cmd.compare("GetImageMType")==0)
			hGmem = Imgctl->GetImageMType(r,len);
		else if(cmd.compare("ToDIB")==0)
			hGmem = Imgctl->ToDIB(r,len);
		else if(cmd.compare("MtoDIB")==0)
			hGmem = Imgctl->MtoDIB(r,len);
		
		// [DIBf[^֐]
		else if(cmd.compare("DeleteDIB")==0)
			hGmem = Imgctl->DeleteDIB(r,len);
		else if(cmd.compare("HeadDIB")==0)
			hGmem = Imgctl->HeadDIB(r,len);
		else if(cmd.compare("PaletteDIB")==0)
			hGmem = Imgctl->PaletteDIB(r,len);
		else if(cmd.compare("PixelDIB")==0)
			hGmem = Imgctl->PixelDIB(r,len);
		else if(cmd.compare("ColorDIB")==0)
			hGmem = Imgctl->ColorDIB(r,len);
		else if(cmd.compare("GetDIB")==0)
			hGmem = Imgctl->GetDIB(r,len);
		else if(cmd.compare("MapDIB")==0)
			hGmem = Imgctl->MapDIB(r,len);
		else if(cmd.compare("DataDIB")==0)
			hGmem = Imgctl->DataDIB(r,len);
		else if(cmd.compare("CreateDIB")==0)
			hGmem = Imgctl->CreateDIB(r,len);
		else if(cmd.compare("CopyDIB")==0)
			hGmem = Imgctl->CopyDIB(r,len);
		else if(cmd.compare("CutDIB")==0)
			hGmem = Imgctl->CutDIB(r,len);
		else if(cmd.compare("TurnDIB")==0)
			hGmem = Imgctl->TurnDIB(r,len);
		else if(cmd.compare("DIBto24Bit")==0)
			hGmem = Imgctl->DIBto24Bit(r,len);
		else if(cmd.compare("DIBto16Bit")==0)
			hGmem = Imgctl->DIBto16Bit(r,len);
		else if(cmd.compare("DIBto16BitEx")==0)
			hGmem = Imgctl->DIBto16BitEx(r,len);
		else if(cmd.compare("DIBto8Bit")==0)
			hGmem = Imgctl->DIBto8Bit(r,len);
		// [24rbgDIBf[^֐]
		else if(cmd.compare("PasteDIB")==0)
			hGmem = Imgctl->PasteDIB(r,len);
		else if(cmd.compare("ResizeDIB")==0)
			hGmem = Imgctl->ResizeDIB(r,len);
		else if(cmd.compare("TurnDIBex")==0)
			hGmem = Imgctl->TurnDIBex(r,len);
		
		// [RLE-DIBf[^֐]
		else if(cmd.compare("IsRLE")==0)
			hGmem = Imgctl->IsRLE(r,len);
		else if(cmd.compare("DIBtoRLE")==0)
			hGmem = Imgctl->DIBtoRLE(r,len);
		else if(cmd.compare("RLEtoDIB")==0)
			hGmem = Imgctl->RLEtoDIB(r,len);
		
		// [Bitmap摜֐]
		else if(cmd.compare("DIBtoBMP")==0)
			hGmem = Imgctl->DIBtoBMP(r,len);
		else if(cmd.compare("BMPtoDIB")==0)
			hGmem = Imgctl->BMPtoDIB(r,len);
		else if(cmd.compare("BMPMtoDIB")==0)
			hGmem = Imgctl->BMPMtoDIB(r,len);
		
		// [JPEG摜֐]
		else if(cmd.compare("DIBtoJPG")==0)
			hGmem = Imgctl->DIBtoJPG(r,len);
		else if(cmd.compare("JPGtoDIB")==0)
			hGmem = Imgctl->JPGtoDIB(r,len);
		else if(cmd.compare("JPGMtoDIB")==0)
			hGmem = Imgctl->JPGMtoDIB(r,len);
		
		// [PNG摜֐]
		else if(cmd.compare("DIBtoPNG")==0)
			hGmem = Imgctl->DIBtoPNG(r,len);
		else if(cmd.compare("DIBtoPNGex")==0)
			hGmem = Imgctl->DIBtoPNGex(r,len);
		else if(cmd.compare("PNGtoDIB")==0)
			hGmem = Imgctl->PNGtoDIB(r,len);
		else if(cmd.compare("PNGMtoDIB")==0)
			hGmem = Imgctl->PNGMtoDIB(r,len);
		else if(cmd.compare("PNGAtoDIB")==0)
			hGmem = Imgctl->PNGAtoDIB(r,len);
		else if(cmd.compare("PNGMAtoDIB")==0)
			hGmem = Imgctl->PNGMAtoDIB(r,len);
		else if(cmd.compare("InfoPNG")==0)
			hGmem = Imgctl->InfoPNG(r,len);
		else if(cmd.compare("InfoPNGM")==0)
			hGmem = Imgctl->InfoPNGM(r,len);
		
		// [GIF摜֐]
		else if(cmd.compare("DIBtoGIF")==0)
			hGmem = Imgctl->DIBtoGIF(r,len);
		else if(cmd.compare("DIBtoGIFex")==0)
			hGmem = Imgctl->DIBtoGIFex(r,len);
		else if(cmd.compare("DIBtoGIFAni")==0)
			hGmem = Imgctl->DIBtoGIFAni(r,len);
		else if(cmd.compare("DIBtoGIFAniEx")==0)
			hGmem = Imgctl->DIBtoGIFAniEx(r,len);
		else if(cmd.compare("GIFtoDIB")==0)
			hGmem = Imgctl->GIFtoDIB(r,len);
		else if(cmd.compare("GIFMtoDIB")==0)
			hGmem = Imgctl->GIFMtoDIB(r,len);
		else if(cmd.compare("GIFtoDIBex")==0)
			hGmem = Imgctl->GIFtoDIBex(r,len);
		else if(cmd.compare("GIFMtoDIBex")==0)
			hGmem = Imgctl->GIFMtoDIBex(r,len);
		
		// [tB^֐]
		else if(cmd.compare("GrayDIB")==0)
			hGmem = Imgctl->GrayDIB(r,len);
		else if(cmd.compare("ReplaceDIB")==0)
			hGmem = Imgctl->ReplaceDIB(r,len);
		else if(cmd.compare("RepaintDIB")==0)
			hGmem = Imgctl->RepaintDIB(r,len);
		else if(cmd.compare("TableDIB")==0)
			hGmem = Imgctl->TableDIB(r,len);
		// [Fϊe[u֐]
		else if(cmd.compare("ToneDIB")==0)
			hGmem = Imgctl->ToneDIB(r,len);
		else if(cmd.compare("ShadeDIB")==0)
			hGmem = Imgctl->ShadeDIB(r,len);
		else if(cmd.compare("GammaDIB")==0)
			hGmem = Imgctl->GammaDIB(r,len);
		else if(cmd.compare("ContrastDIB")==0)
			hGmem = Imgctl->ContrastDIB(r,len);
		
		// [ʊ֘A֐]
		else if(cmd.compare("DIBtoDC")==0)
			hGmem = Imgctl->DIBtoDC(r,len);
		else if(cmd.compare("DIBtoDCex")==0)
			hGmem = Imgctl->DIBtoDCex(r,len);
		else if(cmd.compare("DIBtoDCex2")==0)
			hGmem = Imgctl->DIBtoDCex2(r,len);
		else if(cmd.compare("DCtoDIB")==0)
			hGmem = Imgctl->DCtoDIB(r,len);
			
		// ⏕
		else if(cmd.compare("DeleteAllDIB")==0)
			hGmem = Imgctl->DeleteAllDIB(r,len);
		
		if(hGmem != 0)
			return hGmem;
	}else if(r.cmd_version.compare(GETVERSION)==0){
		mes("GetVersion");
		return set_return(RES_MES_OK CHARSET CRLF,len);
	}

	// ܂ŗ̂̓G[
	return set_return(BAD_MES,len);
}

// 񋓑̂R[hy[W̒l
inline UINT codepage(CharSet c){
	switch(c){
		case SJIS:
			return 932U;
		case UTF8:
		case UTF8N:
			return CP_UTF8;
		case JIS:
			return 50220U;
		case EUCJP:
			return 20932U;
	}
	return CP_ACP;
}

inline std::string cp2str(CharSet c){
	switch(c){
		case SJIS:
			return "Shift_JIS";
		case UTF8:
		case UTF8N:
			return "UTF-8";
		case JIS:
			return "ISO-2022-JP";
		case EUCJP:
			return "EUC-JP";
	}
	return "ASCII";
}

// Cӂ̃}`oCgR[hɕϊ
void conv_to_multi(const std::wstring &from,std::string &to,CharSet c){
	UINT cp = codepage(c);
	int len = WideCharToMultiByte(cp,0,from.c_str(),-1,NULL,0,NULL,NULL);
	char *buf = new char[len+1];
	memset(buf,'\0',(len+1)*sizeof(char));
	WideCharToMultiByte(cp,0,from.c_str(),-1,buf,len,NULL,NULL);
	to.assign(buf);
	delete [] buf;
	return;
}
//Cӂ̃}`oCgR[h烏Chɕϊ
void conv_to_wide(const std::string &from,std::wstring &to,CharSet c){
	UINT cp = codepage(c);
	int len = MultiByteToWideChar(cp,0,from.c_str(),-1,NULL,0);
	wchar_t *buf = new wchar_t[len+1];
	memset(buf,'\0',(len+1)*sizeof(wchar_t));
	len = MultiByteToWideChar(cp,0,from.c_str(),-1,buf,len);
	to.assign(buf);
	delete [] buf;
	return;
}
//}`oCg}`oCg
void conv_multi(const std::string &from,std::string &to,CharSet from_c,CharSet to_c){
	std::wstring buf;
	if(from_c == to_c)
		to = from;
	else{
		conv_to_wide(from,buf,from_c);
		conv_to_multi(buf,to,to_c);
	}
	return;
}
// wstring烌X|X(HGLOBAL)𐶐
inline HGLOBAL set_returnW(std::wstring mes,long *len){
	HGLOBAL h;
	std::string res;
	
	mes_w(mes.c_str());
	
	conv_to_multi(mes,res,UTF8N);
	
	*len = (long)res.size();
	h  = GlobalAlloc(GPTR,*len);
	
	memmove((void*)h,(void*)res.c_str(),*len);
	
	return h;
}

// string烌X|X(HGLOBAL)𐶐
inline HGLOBAL set_returnA(std::string _mes,long *len){
	std::wstring buf;
	conv_to_wide(_mes,buf,SJIS);
	return set_returnW(buf,len);
}

